def find_path_maze(M, row, col, incr, exit_row, exit_col):
    # Базовый случай: проверка, найден ли путь
    if row == exit_row and col == exit_col:
        return True  # Решение найдено
    else:
        sol_found = False
        # Генерация кандидатов
        k = 0
        while not sol_found and k < 4:

            # Новая ячейка-кандидат
            new_col = col + incr[k][0]
            new_row = row + incr[k][1]

            # Проверка кандидата на валидность
            if (new_row >= 0 and new_row < len(M)
                    and new_col >= 0 and new_col < len(M[0])
                    and M[new_row][new_col] == 'E'):

                # Добавить к пути (частичное решение)
                M[new_row][new_col] = 'P'

                # Пробуем расширить путь, начиная с новой ячейки
                sol_found = find_path_maze(
                    M, new_row, new_col, incr,
                    exit_row, exit_col)

                # Отметить как пустую, если новая ячейка не находится в решении
                if not sol_found:
                    M[new_row][new_col] = 'E'

            k = k + 1

        return sol_found


def find_path_maze_wrapper(M, enter_row, enter_col,
                           exit_row, exit_col):
    # направления поиска
    incr = [(0, 1), (1, 0), (0, -1), (-1, 0)]

    M[enter_row][enter_col] = 'P'
    return find_path_maze(M, enter_row, enter_col, incr,
                          exit_row, exit_col)
